unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, Grids,
  AIOUSB;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    ADCDataSG: TStringGrid;
    PageControl1: TPageControl;
    TabSheet3: TTabSheet;
    RadioGroup1: TRadioGroup;
    TabSheet4: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    GroupBox4: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Label19: TLabel;
    ScanRateEdit: TEdit;
    UpDown3: TUpDown;
    Label20: TLabel;
    Edit4: TEdit;
    UpDown4: TUpDown;
    Edit5: TEdit;
    Label21: TLabel;
    Memo1: TMemo;
    ADCLabel: TLabel;
    C1: TCheckBox;
    C2: TCheckBox;
    GroupBox5: TGroupBox;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    C3: TCheckBox;
    C4: TCheckBox;
    L1: TCheckBox;
    L2: TCheckBox;
    L3: TCheckBox;
    L4: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
    procedure DigClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DACChange(Sender: TObject);
  private
    procedure polldata(Sender: TObject; var Done: Boolean);
    function HandleStatus(stat: Longword; msg: String; bVerbose: Boolean = True): Longword;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ADC_SetConfigArray: array[0..20] of Byte;
  PollsPerformed: Longword;

implementation

{$R *.DFM}

function TForm1.HandleStatus(stat: Longword; msg: String; bVerbose: Boolean):Longword;
begin
  Result := stat;
  case stat of
    0: if bVerbose then memo1.Lines.add(msg + ' success');
    1460: memo1.Lines.add(msg + ' Timeout');
  end;//case
end;

procedure TForm1.polldata(Sender: TObject; var Done: Boolean);
  var
    i, Scan: Integer;
    Status: Longword;
    ScansToRead: Longword;
    buf: array of double;
begin
  ScansToRead := ADCDataSG.ColCount -1;
  SetLength( buf, ScansToRead * 16 ); // #scans.to.read * #channels.per.scan
  HandleStatus( ADC_ReadData(diOnly, @ADC_SetConfigArray[0], ScansToRead, @buf[0], 3), 'ADC_ReadData', FALSE);

  inc(PollsPerformed);
  for Scan := 1 to ScansToRead do
  for i := 0 to 15 do
    ADCDataSG.Cells[Scan, i+1] := Format('%g', [buf[(Scan-1) * 16 + i]]);
  ADCLabel.Caption := TimeToStr(Now) + ' ' + IntToStr(PollsPerformed) + 'polls';
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
  var
    Hz: double;
    L: Longword;
    Status: Longword;
    outs: byte;
    data: word;
begin
  Application.OnIdle := polldata;

  HandleStatus(ADC_BulkContinuousEnd(diOnly, 0), 'ADC_BulkContinuousEnd');

  GetDevices;
  outs := 1; // first port output, second port input
  data := $FFFF; // both ports output high to start

  HandleStatus(DIO_Configure(diOnly, false, @outs, @data), 'DIO_Configure: ');

  PollsPerformed := 0;
  Hz := 20480.0;
  L := 21;
  ADC_SetConfigArray[ 0] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 1] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 2] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 3] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 4] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 5] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 6] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 7] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 8] :=   1; // range +/- 10V
  ADC_SetConfigArray[ 9] :=   1; // range +/- 10V
  ADC_SetConfigArray[10] :=   1; // range +/- 10V
  ADC_SetConfigArray[11] :=   1; // range +/- 10V
  ADC_SetConfigArray[12] :=   1; // range +/- 10V
  ADC_SetConfigArray[13] :=   1; // range +/- 10V
  ADC_SetConfigArray[14] :=   1; // range +/- 10V
  ADC_SetConfigArray[15] :=   1; // range +/- 10V
  ADC_SetConfigArray[16] :=   0; // not calibration mode
  ADC_SetConfigArray[17] :=   5; // timer start mode
  ADC_SetConfigArray[18] := $F0; // Channels 0-15
  ADC_SetConfigArray[19] :=   0; // no Oversamples
  ADC_SetConfigArray[20] :=   0; // upper channel#s 0

  HandleStatus(ADC_FullStartRing(diOnly, @ADC_SetConfigArray[0], L, PChar(nil), @Hz, 655360, 6 ), 'ADCStart Status:');

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  HandleStatus(ADC_BulkContinuousEnd(diOnly, 0), 'ADC_BulkContinuousEnd');
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Application.OnIdle := nil;
  HandleStatus(ADC_BulkContinuousEnd(diOnly, 0), 'ADC_BulkContinuousEnd');
end;

procedure TForm1.DigClick(Sender: TObject);
begin
  HandleStatus(
    DIO_Write1(diOnly, (Sender as TCheckBox).tag, (Sender as TCheckBox).Checked),
    'DIO' + IntToStr((Sender as TCheckBox).tag)+ ' = ' + IntToStr(ord((Sender as TCheckBox).Checked)) + ':'
  );
end;

procedure TForm1.FormCreate(Sender: TObject);
  var
    i: Integer;
begin
  ADCDataSG.Cells[0,0] := 'CH';
  ADCDataSG.Cells[1,0] := 'V';
  for i := 0 to 15 do
    ADCDataSG.Cells[0,i+1] := Format('%d', [i]);
end;

procedure TForm1.DACChange(Sender: TObject);
  var
    DACNum: Longword;
    Counts: Longword;
begin
  DACNum := (Sender as TEdit).tag;
  Counts := trunc(StrToFloat((Sender as TEdit).Text) * 0.02 * 13107);
  if HandleStatus( DACDirect(diOnly, DACNum, Counts), 'DACDirect: ') = 0 then
    memo1.lines.add( 'DAC ' + IntToStr(DACNum) + ' = ' + IntToStr(Counts) );
end;

end.
